settings = {
    fgcolor        = 0xeeeeee,
    bgcolor        = 0x999999
}

jobs = {
    {
        job='text',
        str='${time %A, %d %B %Y}',
        isparsable=true,
        font='Sans',
        size=22,
        x = 30, y = 90
    },
    {
        job='text',
        str='${uptime}',
        isparsable=true,
        font='Sans',
        size=16,
        x = 170, y = 110
    },
    {
        job='text',
        str='${time %H:%M}',
        isparsable=true,
        font='Monospace',
        size=23,
        x = 135, y = 207
    },
    {
        job = 'ring',
        layers = {
            {
                angle1 = 360,
                angle2 = 0,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = -90,
                angle2 = -450,
                value = '${time %S}',
                valuemax = 60,
                alpha = 1,
                isparsable = true
            }
        },
        radius = 55,
        width = 5,
        x = 170, y = 200
    },
    {
        job = 'ring',
        layers = {
            {
                angle1 = 40,
                angle2 = -40,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = 220,
                angle2 = 140,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = 40,
                angle2 = -40,
                alpha = 1,
                value = '${cpu cpu2}',
                valuemax = 100,
                isparsable = true
            },
            {
                angle1 = 220,
                angle2 = 140,
                alpha = 1,
                value = '${cpu cpu3}',
                valuemax = 100,
                isparsable = true
            }
        },
        radius = 42,
        width = 5,
        x = 170, y = 200
    },
    {
        job = 'ring',
        layers = {
            {
                angle1 = 30,
                angle2 = -80,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = 190,
                angle2 = 120,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = 190,
                angle2 = 120,
                value = '${time %M}',
                valuemax = 60,
                alpha = 0.75,
                isparsable = true
            },
            {
                angle1 = 30,
                angle2 = -80,
                value = '${time %H}',
                valuemax = 24,
                alpha = 0.75,
                isparsable = true
            }
        },
        radius = 68,
        width = 5,
        x = 170, y = 200
    },
    {
        job = 'ring',
        layers = {
            {
                angle1 = 360,
                angle2 = 0,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = -90,
                angle2 = -450,
                alpha = 1,
                value = '${memperc}',
                valuemax = 100,
                isparsable = true
            }
        },
        radius = 28,
        width = 5,
        x = 170, y = 300
    },
    {
        job = 'ring',
        layers = {
            {
                angle1 = 45,
                angle2 = -45,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = 45,
                angle2 = -45,
                alpha = 1,
                value = '${cpu cpu0}',
                valuemax = 100,
                isparsable = true
            },
            {
                angle1 = 225,
                angle2 = 135,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = 225,
                angle2 = 135,
                alpha = 1,
                value = '${cpu cpu1}',
                valuemax = 100,
                isparsable = true
            }
        },
        radius = 39,
        width = 5,
        x = 170, y = 300
    },
    {
        job = 'text',
        str = '${memperc}',
        isparsable = true,
        fmt = '%02d',
        isformatable = true,
        font = 'Monospace',
        size = 23,
        x = 156, y = 310
    },
    {
        job = 'line',
        layers = {
            {
                alpha = 1,
                isparsable = false
            },
            {
                alpha = 0.5,
                value = '${platform coretemp.0 temp 1}',
                valuemax = 88,
                isparsable = true
            },
            {
                alpha = 1,
                value = '${platform coretemp.1 temp 1}',
                valuemax = 150,
                isparsable = true
            }
        },
        width = 5,
        x1 = 170, y1 = 342,
        x2 = 0, y2 = 200
    },
    {
        job = 'line',
        layers = {
            {
                alpha = 1,
                isparsable = false
            },
            {
                alpha = 0.6,
                value = '${downspeedf eth0}',
                valuemax = 100,
                isparsable = true
            },
            {
                alpha = 0.75,
                value = '${downspeedf eth0}',
                valuemax = 600,
                isparsable = true
            },
            {
                alpha = 1,
                value = '${downspeedf eth0}',
                valuemax = 4000,
                isparsable = true
            }
        },
        width = 5,
        x1 = 157, y1 = 362,
        x2 = 0, y2 = 160
    },
    {
        job = 'text',
        str = '${platform coretemp.1 temp 1}',
        isparsable = true,
        fmt = '%02d',
        isformatable = true,
        font = 'Monospace',
        size = 23,
        x = 156, y = 600
    },
    {
        job = 'line',
        layers = {
            {
                alpha = 1,
                isparsable = false
            },
            {
                alpha = 0.6,
                value = '${upspeedf eth0}',
                valuemax = 35,
                isparsable = true
            },
            {
                alpha = 0.75,
                value = '${upspeedf eth0}',
                valuemax = 100,
                isparsable = true
            },
            {
                alpha = 1,
                value = '${upspeedf eth0}',
                valuemax = 4000,
                isparsable = true
            }
        },
        width = 5,
        x1 = 183, y1 = 362,
        x2 = 0, y2 = 160
    },
    {
        job = 'ring',
        layers = {
            {
                angle1 = 360,
                angle2 = 0,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = 270,
                angle2 = -90,
                alpha = 1,
                value = '${fs_used_perc /}',
                valuemax = 100,
                isparsable = true
            }
        },
        width = 5,
        radius = 35,
        x = 170, y = 590
    },
    {
        job = 'ring',
        layers = {
            {
                angle1 = 250,
                angle2 = -70,
                alpha = 1,
                isparsable = false
            },
            {
                angle1 = 250,
                angle2 = -70,
                alpha = 1,
                value = '${fs_used_perc /home}',
                valuemax = 100,
                isparsable = true
            }
        },
        width = 5,
        radius = 47,
        x = 170, y = 590
    }
}







require 'cairo'

function inca_rgb(color,alpha)
    return ((color / 0x10000) % 0x100) / 255., ((color / 0x100) % 0x100) / 255., (color % 0x100) / 255., alpha
end


function inca_draw_shadow(cr, radius, color, strength, radiusstart)
    local alpha = strength / radius
    cairo_set_source_rgba(cr, inca_rgb(color, alpha))
    cairo_set_line_join(cr, CAIRO_LINE_JOIN_ROUND)
    cairo_set_line_cap(cr, CAIRO_LINE_CAP_ROUND)
    local w, radiusstart = 0, radiusstart
    if radiusstart     ~= nil and radiusstart > 1 then
        radius = radius + radiusstart
    else
        radiusstart = 1
    end
    for w=radiusstart,radius,1 do
        cairo_set_line_width(cr, w)
        cairo_stroke_preserve(cr)
    end
end

function inca_draw_ring(cr, x, y, radius, width, ring)
    local value,valuemax = ring['value'], ring['valuemax']
    local angle1,angle2,angle3 = ring['angle1'], ring['angle2'], 0
    local color,alpha = settings['fgcolor'], ring['alpha']
    local alphasd = 0.3
        
    if ring['isparsable'] == true then
        value = conky_parse(value)
        if value == nil then return end
        value = tonumber(value)/valuemax
        value = math.max(0, math.min(1, value))
    else
        value = 1
        alphasd = 1
        color = settings['bgcolor']
    end
    angle3 = (angle2 - angle1)*value + angle1
    cairo_arc_negative(cr, x, y, radius, angle1*math.pi/180, angle3*math.pi/180)
    inca_draw_shadow(cr, 5, 0x000000, 0.60*alphasd, width + 1)
    cairo_set_source_rgba(cr, inca_rgb(color,alpha))
    cairo_set_line_width(cr, width)
    cairo_stroke(cr)
end

function inca_draw_line(cr, x1, y1, x2, y2, width, line)
    local value,valuemax = line['value'], line['valuemax']
    local color,alpha = settings['fgcolor'], line['alpha']
    local alphasd = 0.3
    
    if line['isparsable'] == true then
        value = conky_parse(value)
        if value == nil then return end
        value = tonumber(value)/valuemax
        value = math.max(0, math.min(1, value))
    else
        value = 1
        alphasd = 1
        color = settings['bgcolor']
    end
    local x = (1 - value)/2
    cairo_move_to(cr, x1 + x2*x, y1 + y2*x)
    cairo_rel_line_to(cr, x2*(1-x*2), y2*(1-x*2))
    cairo_close_path (cr)
    inca_draw_shadow(cr, 5, 0x000000, 0.60*alphasd, width + 1)
    cairo_set_source_rgba(cr, inca_rgb(color, alpha))
    cairo_set_line_width(cr, width)
    cairo_stroke(cr)
end

function inca_draw_job(cr, job)
    if job['job'] == 'text' then
        cairo_select_font_face(cr, job.font, CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD)
        cairo_set_font_size(cr, job.size)
        cairo_move_to(cr, job['x'], job['y'])
        local str = job['str']
        if job['isparsable'] == true then
            str = conky_parse(str)
            if str == nil then return end
        end
        if job['isformatable'] ~= nil and job['isformatable'] == true then
            str = string.format(job['fmt'], str)
        end
        cairo_text_path(cr, str)
        inca_draw_shadow(cr, 5, 0x000000, 0.65)
        cairo_set_source_rgba(cr, inca_rgb(settings['fgcolor'], 1))
        cairo_fill(cr)
    elseif job['job'] == 'ring' then
        local x,y,radius = job['x'], job['y'], job['radius']
        local layers,width = job['layers'], job['width']
        for i in pairs(layers) do
            inca_draw_ring(cr, x, y, radius, width, layers[i])
        end
    elseif job['job'] == 'line' then
        local x1,y1,x2,y2 = job['x1'], job['y1'], job['x2'], job['y2']
        local layers,width = job['layers'], job['width']
        for i in pairs(layers) do
            inca_draw_line(cr, x1, y1, x2, y2, width, layers[i])
        end
    end
end

function conky_paint()
    if conky_window == nil then return end
    local cs = cairo_xlib_surface_create(conky_window.display,conky_window.drawable,conky_window.visual, conky_window.width,conky_window.height)
     local cr = cairo_create(cs)
    for i in pairs(jobs) do
        inca_draw_job(cr, jobs[i])
    end
end
